*+--------------------------------------------------------------------
*+
*+ Source Module => c:\hmg.3.4.4\0\MYBUTT2\\DEMO1.PRG
*+
*+    Copyright(C) 1983-2020 by Auge & Ohr
*+
*+    Functions: Function Main()
*+               Function OBTNEVENTS()
*+               Function DoPaint()
*+               Function ButtonEvHandler()
*+               Function OBTN_Draw()
*+               Function OBTN_Shape()
*+               Function OLAB_Handle()
*+               Function MyColor()
*+               Function RGBfromArray()
*+               Procedure HMG_InfoControlWithCursor()
*+
*+    Reformatted by Click! 2.05.36 on Dec-18-2020 at  6:12 am
*+
*+--------------------------------------------------------------------

/*
 * HMG User Components Demo1
 * (c) 2006 Roberto Lopez
 *
 * Version 1.4
 *
 * Revised by Pablo César on April 6th, 2016
 *   - Added directives at i_UsrSOOP.ch
 *   - Created local directive i_UsrInit.ch
 *   - Added Width, Height and MULTINE at Button functions
 *   - MyButton.prg included at .hbp (project file)
 *
 * Revised by Jimmy on Dec. 16th, 2020
 * - Added CALLBACK . here used for hover Color
 * - Added simple HBRUSH LinearGradientBrush() (4 Color Element )
 * - Added MYBUTTON.CH for _HMG_SYSDATA
 * - try to add more Parameter ( GOTFOCUS / LOSTFOCUS )
 */

#include "hmg.ch"
#include "i_UsrInit.ch"
#include "MYBUTTON.CH"

STATIC BGcolor  := { 56, 56, 56 }                // "the" Background Color
STATIC GB1color := { 56, 56, 56 }                // normal Background Color
STATIC GB2color := { 192, 192, 192 }             // 2nd. Gradient Color
STATIC WBGcolor := { 255, 0, 0 }                 // Hot Background Color

MEMVAR _HMG_SYSDATA
MEMVAR lVisible

*+--------------------------------------------------------------------
*+
*+    Function Main()
*+
*+--------------------------------------------------------------------
*+
FUNCTION Main()

LOCAL nShape     := 10
PRIVATE lVisible := .T.

   DEFINE WINDOW Form_1 AT 0, 0 WIDTH 1280 HEIGHT 140 ;
         TITLE 'Demo of Custom Button Control and User Properties' MAIN

*      DEFINE MAIN MENU
*         DEFINE POPUP 'Test Menu'
*            MENUITEM 'Custom Method: Button Visible (On/Off)' ACTION( lVisible := IF( lVisible, .F., .T. ), Form_1.Test1.Visible := lVisible )
*            MENUITEM 'Custom Method: Print Form in default' ACTION Form_1.Print
*            MENUITEM 'Custom Method: Print() with Preview' ACTION Form_1.Print()
*            MENUITEM 'Custom Method: Disable' ACTION Form_1.Test1.Disable
*            MENUITEM 'Custom Method: Enable' ACTION Form_1.Test1.Enable
*            MENUITEM 'Custom Property: Handle (Get)' ACTION MsgInfo( STR( Form_1.Test1.Handle ), 'MyButton handle' )
*            MENUITEM 'Custom Property: Handle (Set)' ACTION Form_1.Test1.Handle := 1
*            MENUITEM 'Custom Property: Caption (Get)' ACTION MsgInfo( Form_1.Test1.Caption, 'MyButton Caption' )
*            MENUITEM 'Custom Property: Caption (Set)' ACTION Form_1.Test1.Caption := 'New Caption'
*            MENUITEM 'Custom Property: Width and Height (Get)' ACTION MsgInfo( 'Width: ' + ALLTRIM( STR( Form_1.Test1.Width ) ) + ' / Height: ' + ALLTRIM( STR( Form_1.Test1.Height ) ), 'MyButton Width & Height' )
*         END POPUP
*      END MENU

      @ 10, 002 MYBUTTON Test1 ;
              OF Form_1 ;
              WIDTH 100 ;
              HEIGHT 64 ;
              CAPTION 'F1 Button' ;
              ACTION MsgInfo( 'Click! 1' ) ;
              ON GOTFOCUS DoPaint( "HOT", This.Name ) ;
              ON LOSTFOCUS DoPaint( "NORMAL", This.Name ) nShape

      @ 10, 104 MYBUTTON Test2 ;
              OF Form_1 ;
              WIDTH 100 ;
              HEIGHT 64 ;
              CAPTION 'F2 Button' ;
              ACTION MsgInfo( 'Click! 2' ) ;
              ON GOTFOCUS DoPaint( "HOT", This.Name ) ;
              ON LOSTFOCUS DoPaint( "NORMAL", This.Name ) nShape

      @ 10, 206 MYBUTTON Test3 ;
              OF Form_1 ;
              WIDTH 100 ;
              HEIGHT 64 ;
              CAPTION 'F3 Button' ;
              ACTION MsgInfo( 'Click! 3' ) ;
              ON GOTFOCUS DoPaint( "HOT", This.Name ) ;
              ON LOSTFOCUS DoPaint( "NORMAL", This.Name ) nShape

      @ 10, 308 MYBUTTON Test4 ;
              OF Form_1 ;
              WIDTH 100 ;
              HEIGHT 64 ;
              CAPTION 'F4 Button' ;
              ACTION MsgInfo( 'Click! 4' ) ;
              ON GOTFOCUS DoPaint( "HOT", This.Name ) ;
              ON LOSTFOCUS DoPaint( "NORMAL", This.Name ) nShape

      @ 10, 422 MYBUTTON Test5 ;
              OF Form_1 ;
              WIDTH 100 ;
              HEIGHT 64 ;
              CAPTION 'F5 Button' ;
              ACTION MsgInfo( 'Click! 5' ) ;
              ON GOTFOCUS DoPaint( "HOT", This.Name ) ;
              ON LOSTFOCUS DoPaint( "NORMAL", This.Name ) nShape

      @ 10, 524 MYBUTTON Test6 ;
              OF Form_1 ;
              WIDTH 100 ;
              HEIGHT 64 ;
              CAPTION 'F6 Button' ;
              ACTION MsgInfo( 'Click! 6' ) ;
              ON GOTFOCUS DoPaint( "HOT", This.Name ) ;
              ON LOSTFOCUS DoPaint( "NORMAL", This.Name ) nShape

      @ 10, 626 MYBUTTON Test7 ;
              OF Form_1 ;
              WIDTH 100 ;
              HEIGHT 64 ;
              CAPTION 'F7 Button' ;
              ACTION MsgInfo( 'Click! 7' ) ;
              ON GOTFOCUS DoPaint( "HOT", This.Name ) ;
              ON LOSTFOCUS DoPaint( "NORMAL", This.Name ) nShape

      @ 10, 728 MYBUTTON Test8 ;
              OF Form_1 ;
              WIDTH 100 ;
              HEIGHT 64 ;
              CAPTION 'F8 Button' ;
              ACTION MsgInfo( 'Click! 8' ) ;
              ON GOTFOCUS DoPaint( "HOT", This.Name ) ;
              ON LOSTFOCUS DoPaint( "NORMAL", This.Name ) nShape

      @ 10, 842 MYBUTTON Test9 ;
              OF Form_1 ;
              WIDTH 100 ;
              HEIGHT 64 ;
              CAPTION 'F9 Button' ;
              ACTION MsgInfo( 'Click! 9' ) ;
              ON GOTFOCUS DoPaint( "HOT", This.Name ) ;
              ON LOSTFOCUS DoPaint( "NORMAL", This.Name ) nShape

      @ 10, 944 MYBUTTON Test10 ;
              OF Form_1 ;
              WIDTH 100 ;
              HEIGHT 64 ;
              CAPTION 'F10 Button' ;
              ACTION MsgInfo( 'Click! 10' ) ;
              ON GOTFOCUS DoPaint( "HOT", This.Name ) ;
              ON LOSTFOCUS DoPaint( "NORMAL", This.Name ) nShape

      @ 10, 1046 MYBUTTON Test11 ;
              OF Form_1 ;
              WIDTH 100 ;
              HEIGHT 64 ;
              CAPTION 'F11 Button' ;
              ACTION MsgInfo( 'Click! 11' ) ;
              ON GOTFOCUS DoPaint( "HOT", This.Name ) ;
              ON LOSTFOCUS DoPaint( "NORMAL", This.Name ) nShape

      @ 10, 1148 MYBUTTON Test12 ;
              OF Form_1 ;
              WIDTH 100 ;
              HEIGHT 64 ;
              CAPTION 'F12 Button' + CRLF + "2nd. line" ;
              ACTION MsgInfo( 'Click! 12' ) ;
              ON GOTFOCUS DoPaint( "HOT", This.Name ) ;
              ON LOSTFOCUS DoPaint( "NORMAL", This.Name ) nShape

   END WINDOW

   InstallEventHandler( "ButtonEvHandler" )

   CENTER WINDOW Form_1
   ACTIVATE WINDOW Form_1
RETURN Nil

*+--------------------------------------------------------------------
*+
*+    Function OBTNEVENTS()
*+
*+--------------------------------------------------------------------
*+
FUNCTION OBTNEVENTS( hWnd, nMsg, wParam, lParam )              // from C-Code

LOCAL i

   IF ( i := ASCAN( _HMG_SYSDATA[ CTRL_HANDLE ], hWnd ) ) > 0 .AND. _HMG_SYSDATA[ CTRL_TYPE ] [ i ] == "MYBUTTON"

      DO CASE
         CASE nMsg = WM_MOUSEMOVE
            IF _HMG_SYSDATA[ CTRL_INPUTMASK ] [ i ]
               SETCURSORSYSTEM( IDC_HAND )
            ENDIF
            _DoControlEventProcedure( _HMG_SYSDATA[ CTRL_GOTFOCUS ] [ i ], i )
            BGcolor := WBGcolor                  // HOT BG-Color
            InvalidateRect( hWnd, 0 )

         CASE nMsg = WM_MOUSELEAVE
            _DoControlEventProcedure( _HMG_SYSDATA[ CTRL_LOSTFOCUS ] [ i ], i )
            BGcolor := GB1color                  // normal BG-Color
            InvalidateRect( hWnd, 0 )

         OTHERWISE
            _DoControlEventProcedure( _HMG_SYSDATA[ CTRL_LOSTFOCUS ] [ i ], i )
            BGcolor := GB1color
            InvalidateRect( hWnd, 0 )
      ENDCASE
   ENDIF

RETURN 0

*+--------------------------------------------------------------------
*+
*+    Function DoPaint()
*+
*+    Called from ( demo1.prg )  24 - function main()
*+
*+--------------------------------------------------------------------
*+
FUNCTION DoPaint( cIn, cControl )

LOCAL Hwnd := GetControlHandle( cControl, "Form_1" )

   BGcolor := GB1color
   InvalidateRect( hWnd, 0 )

RETURN Nil

*+--------------------------------------------------------------------
*+
*+    Function ButtonEvHandler()
*+
*+--------------------------------------------------------------------
*+
FUNCTION ButtonEvHandler( nHWnd, nMsg, nWParam, nLParam )

LOCAL HWnd   := nHWnd
LOCAL Msg    := nMsg
LOCAL WParam := nWParam
LOCAL LParam := nLParam
LOCAL nID, nForm := GetFormHandle( "Form_1" )

   IF nHWnd == nForm
      IF nMsg == WM_DRAWITEM
         nID := GetDlgCtrlID( GetFocus() )
         OBTN_Draw( nHWnd, nID, nLParam )
         RETURN 1
      ENDIF
   ENDIF

RETURN NIL

*+--------------------------------------------------------------------
*+
*+    Function OBTN_Draw()
*+
*+    Called from ( demo1.prg )   1 - function buttonevhandler()
*+
*+--------------------------------------------------------------------
*+
FUNCTION OBTN_Draw( nHParent, nID, nDRAWITEMSTRUCT )

LOCAL cForm     := GetFormNameByIndex( GetFormIndexByHandle( nHParent ) )
LOCAL nShape    := OBTN_Shape( cForm, nID )
LOCAL aColor    := MyColor( BGcolor, GB2color )                       // OBTN_Color( cForm, nID )
LOCAL aFont     := { "Arial", 9, .T., .F., .F., .F. }                 // OBTN_Font( cForm, nID )
LOCAL nPosi
LOCAL hWnd, nCol, nRow
LOCAL cFormName, cControlName, hButton

   GetCursorPos( @nCol, @nRow )
   hWnd := WindowFromPoint( nCol, nRow )
   IF GetControlIndexByHandle( hWnd ) > 0
      GetControlNameByHandle( hWnd, @cControlName, @cFormName )
      hButton := GetMyButtonHandle( cFormName, cControlName )
   ELSE
      nPosi := ASCAN( _HMG_SYSDATA[ CTRL_ID ], nID )
      IF nPosi > 0 .AND. _HMG_SYSDATA [ CTRL_TYPE ] [nPosi] == "MYBUTTON"
         hButton := _HMG_SYSDATA[ CTRL_HANDLE ] [ nPosi ]
         cControlName := _HMG_SYSDATA[ CTRL_NAME ] [ nPosi ]
      ENDIF
   ENDIF

*   IF !EMPTY( hButton )
      OwnButtonDraw( nDRAWITEMSTRUCT, nShape, aColor[ 1 ], aColor[ 2 ], aColor[ 3 ], aFont, hButton )
*   ENDIF
RETURN NIL

*+--------------------------------------------------------------------
*+
*+    Function OBTN_Shape()
*+
*+    Called from ( demo1.prg )   1 - function obtn_draw()
*+
*+--------------------------------------------------------------------
*+
FUNCTION OBTN_Shape( cForm, nID, nShape, lRedraw )

LOCAL nHwnd

STATIC hShape := { => }

   IF VALTYPE( nShape ) == "N"
      IF HB_hHaskey( hShape, cForm )
         hShape[ cForm ] [ nID ] := nShape
      ELSE
         hShape[ cForm ] := { nID => nShape }
      ENDIF

      IF ( VALTYPE( lRedraw ) == "L" ) .AND. lRedraw
         ERASE WINDOW &cForm
         RedrawWindow( GetDlgItem( GetFormHandle( cForm ), nID ) )
      ENDIF
   ELSE
      IF HB_hHaskey( hShape, cForm ) .AND. HB_hHaskey( hShape[ cForm ], nID )
         nShape := hShape[ cForm ] [ nID ]
      ENDIF
   ENDIF

RETURN nShape

*+--------------------------------------------------------------------
*+
*+    Function OLAB_Handle()
*+
*+--------------------------------------------------------------------
*+
FUNCTION OLAB_Handle( cForm, nID )

RETURN GetDlgItem( GetFormHandle( cForm ), nID )

*+--------------------------------------------------------------------
*+
*+    Function MyColor()
*+
*+    Called from ( demo1.prg )   1 - function obtn_draw()
*+
*+--------------------------------------------------------------------
*+
FUNCTION MyColor( aColor, aGradient )

LOCAL aBtnColor := {}
LOCAL aDummy    := {}

   // normal
   AADD( aDummy, RGBfromArray( CYAN ) )                               // Text
   AADD( aDummy, RGBfromArray( aColor ) )                             // backgound
   AADD( aDummy, RGBfromArray( BLACK ) )                              // frame
   AADD( aDummy, RGBfromArray( aGradient ) )                          // 2nd Gradient Color
   AADD( aBtnColor, ACLONE( aDummy ) )

   // (pDIS->itemState & ODS_DISABLED)
   aDummy := {}
   AADD( aDummy, RGBfromArray( GRAY ) )                               // Text
   AADD( aDummy, RGBfromArray( aColor ) )                             // backgound
   AADD( aDummy, RGBfromArray( BLACK ) )                              // frame
   AADD( aDummy, RGBfromArray( GRAY ) )                               // 2nd Gradient Color
   AADD( aBtnColor, ACLONE( aDummy ) )

   // (pDIS->itemState & ODS_FOCUS)
   aDummy := {}
   AADD( aDummy, RGBfromArray( BLACK ) )                              // Text
   AADD( aDummy, RGBfromArray( RED ) )                                // backgound
   AADD( aDummy, RGBfromArray( BLACK ) )                              // frame
   AADD( aDummy, RGBfromArray( WHITE ) )                              // 2nd Gradient Color
   AADD( aBtnColor, ACLONE( aDummy ) )

RETURN aBtnColor

*+--------------------------------------------------------------------
*+
*+    Function RGBfromArray()
*+
*+    Called from ( demo1.prg )  12 - function mycolor()
*+
*+--------------------------------------------------------------------
*+
FUNCTION RGBfromArray( aRGB )

RETURN RGB( aRGB[ 1 ], aRGB[ 2 ], aRGB[ 3 ] )

*+ EOF: DEMO1.PRG

