*------------------------------------------------------------------------------*
* Low Level C Routines
*------------------------------------------------------------------------------*

#pragma BEGINDUMP

#include "windows.h"
#include "commctrl.h"
#include "hbapi.h"
#include "hbapiitm.h"
#include "hbvm.h"
#include "winuser.h"

LRESULT CALLBACK OwnButtonProc( HWND hbutton, UINT msg, WPARAM wParam, LPARAM lParam );
static WNDPROC ButtonOldWndProc;

HBRUSH LinearGradientBrush( HDC pDC, long cx, long cy, COLORREF crFrom, COLORREF crTo, BOOL bVert )
{
   HDC     memDC;
   HBITMAP memBmp;
   HBRUSH  pGradientBrush = ( HBRUSH ) NULL;

   memDC  = CreateCompatibleDC( pDC );
   memBmp = CreateCompatibleBitmap( pDC, cx, cy );

   if( memDC && memBmp )
   {
      TRIVERTEX     rcVertex[ 3 ];
      GRADIENT_RECT gRect;

      rcVertex[ 0 ].x     = 0;
      rcVertex[ 0 ].y     = 0;
      rcVertex[ 0 ].Red   = ( unsigned short ) ( GetRValue( crFrom ) << 8 );
      rcVertex[ 0 ].Green = ( unsigned short ) ( GetGValue( crFrom ) << 8 );
      rcVertex[ 0 ].Blue  = ( unsigned short ) ( GetBValue( crFrom ) << 8 );
      rcVertex[ 0 ].Alpha = 0;

      rcVertex[ 1 ].x     = cx;
      rcVertex[ 1 ].y     = cy;
      rcVertex[ 1 ].Red   = ( unsigned short ) ( GetRValue( crTo ) << 8 );
      rcVertex[ 1 ].Green = ( unsigned short ) ( GetGValue( crTo ) << 8 );
      rcVertex[ 1 ].Blue  = ( unsigned short ) ( GetBValue( crTo ) << 8 );
      rcVertex[ 1 ].Alpha = 0;

      rcVertex[ 2 ].x     = cx;
      rcVertex[ 2 ].y     = cy;
      rcVertex[ 2 ].Red   = ( unsigned short ) ( GetRValue( crFrom ) << 8 );
      rcVertex[ 2 ].Green = ( unsigned short ) ( GetGValue( crFrom ) << 8 );
      rcVertex[ 2 ].Blue  = ( unsigned short ) ( GetBValue( crFrom ) << 8 );
      rcVertex[ 2 ].Alpha = 0;

      gRect.UpperLeft  = 0;
      gRect.LowerRight = 1;

      SelectObject( memDC, memBmp );

      GdiGradientFill( memDC, rcVertex, 3, &gRect, 2, bVert ? GRADIENT_FILL_RECT_V : GRADIENT_FILL_RECT_H );
//    GdiGradientFill( memDC, rcVertex, 3, &gRect, 3, bVert ? GRADIENT_FILL_TRIANGLE : GRADIENT_FILL_TRIANGLE );

      pGradientBrush = CreatePatternBrush( memBmp );

      DeleteObject( memBmp );
      DeleteObject( memDC );
   }

   return pGradientBrush;
}

//                1                  2     3     4         5    6       7        8
// InitMyButton ( nParentFormHandle, nRow, nCol, cCaption, nId, nWidth, nHeight, lMultiline )
HB_FUNC( INITMYBUTTON )
{
    HWND hwnd = (HWND) hb_parnl (1) ;
    HWND hbutton;
    INT  Style;

   // Style = WS_CHILD | BS_PUSHBUTTON | WS_VISIBLE | BS_OWNERDRAW ;
   Style = BS_NOTIFY | WS_CHILD | BS_PUSHBUTTON | WS_VISIBLE | BS_OWNERDRAW  ;

   if( hb_parl( 8 ) )
      Style = Style | BS_MULTILINE ;

    hbutton = CreateWindowEx( 0, "button" ,
                           hb_parc(4) ,
                           Style ,
                           hb_parni(3) ,
                           hb_parni(2) ,
                           hb_parni(6) ,
                           hb_parni(7) ,
                           hwnd ,
                           (HMENU)hb_parni(5) ,
                           GetModuleHandle(NULL) ,
                           NULL ) ;

    ButtonOldWndProc = ( WNDPROC ) SetWindowLongPtr( ( HWND ) hbutton, GWLP_WNDPROC, ( LONG_PTR ) OwnButtonProc );

    hb_retnl ( (LONG) hbutton );
}

//               1                2       3        4        5        6      7
// OwnButtonDraw(nDRAWITEMSTRUCT, nShape, aColor1, aColor2, aColor3, aFont, hWnd)
HB_FUNC( OWNBUTTONDRAW )
  {
    DRAWITEMSTRUCT *pDIS = (DRAWITEMSTRUCT *) hb_parnl(1);

    INT nShape = (INT) hb_parni(2);

    TCHAR *FontName  = (TCHAR *) hb_parvc(6, 1);
    INT   nFontSize  = (INT)     hb_parvni(6, 2);
    INT   nBold      = hb_parvl(6, 3) ? FW_BOLD : FW_NORMAL;
    INT   nItalic    = hb_parvl(6, 4) ? 1 : 0;
    INT   nUnderline = hb_parvl(6, 5) ? 1 : 0;
    INT   nStrikeOut = hb_parvl(6, 6) ? 1 : 0;
    HWND MyControl   = ( HWND ) hb_parnl(7);

    COLORREF TextColor;
    COLORREF BackColor;
    COLORREF FrameColor;
    COLORREF FrameColor2 = 0xFFFFFFFF;
    COLORREF GradientColor = 0x80808080;
    HBRUSH   hBrush;
    HBRUSH   hBrush2;
    HBRUSH   hBrushOld;
    HPEN     hPen;
    HPEN     hPenOld;
    HFONT    hFont;
    HFONT    hFontOld;
    RECT     rcText;
    INT      nTextH;
    HRGN     hRegn;

    INT nTextLen = GetWindowTextLength(pDIS->hwndItem) + 1;
    TCHAR *Text  = (TCHAR *) hb_xgrab(nTextLen * sizeof(TCHAR));
    GetWindowText(pDIS->hwndItem, Text, nTextLen);

    if (pDIS->itemState & ODS_DISABLED)
    {
      TextColor  = (COLORREF) hb_parvni(4, 1);   // aColor2
      BackColor  = (COLORREF) hb_parvni(4, 2);
      FrameColor = (COLORREF) hb_parvni(4, 3);
//      FrameColor2 = (COLORREF) hb_parvni(5, 3);
      GradientColor = (COLORREF) hb_parvni(4, 4);
    }
//   else if (pDIS->itemState & ODS_HOTLIGHT)
//   {
//     TextColor   = (COLORREF) hb_parvni(5, 1);  // aColor3
//     BackColor   = (COLORREF) hb_parvni(5, 2);
//     FrameColor  = (COLORREF) hb_parvni(3, 3);
//     FrameColor2 = (COLORREF) hb_parvni(5, 3);
//     GradientColor = (COLORREF) hb_parvni(5, 4);
//   }
    else if (pDIS->itemState & ODS_SELECTED)
    {
      TextColor   = (COLORREF) hb_parvni(5, 1);  // aColor3
      BackColor   = (COLORREF) hb_parvni(5, 2);
      FrameColor  = (COLORREF) hb_parvni(3, 3);
      FrameColor2 = (COLORREF) hb_parvni(5, 3);
      GradientColor = (COLORREF) hb_parvni(5, 4);
    }
//    else if (pDIS->itemState & ODS_FOCUS)
//    {
//      TextColor   = (COLORREF) hb_parvni(5, 1);
//      BackColor   = (COLORREF) hb_parvni(5, 2);
//      FrameColor  = (COLORREF) hb_parvni(3, 3);
//      FrameColor2 = (COLORREF) hb_parvni(5, 3);
//      GradientColor = (COLORREF) hb_parvni(5, 4);
//    }
    else
    {
      TextColor  = (COLORREF) hb_parvni(3, 1);   // aColor1
      BackColor  = (COLORREF) hb_parvni(3, 2);
      FrameColor = (COLORREF) hb_parvni(3, 3);
      FrameColor2 = (COLORREF) hb_parvni(5, 3);
      GradientColor = (COLORREF) hb_parvni(3, 4);
    }

    rcText.left   = pDIS->rcItem.left;
    rcText.top    = pDIS->rcItem.top ;
    rcText.right  = pDIS->rcItem.right;
    rcText.bottom = pDIS->rcItem.bottom;

//    hBrush = CreateSolidBrush(BackColor);
    hBrush = LinearGradientBrush(pDIS->hDC,(rcText.right-rcText.left),(rcText.bottom-rcText.top),BackColor,GradientColor,FALSE);
    hPen   = CreatePen(PS_INSIDEFRAME, 1, FrameColor);
    hFont  = CreateFont(-MulDiv(nFontSize, GetDeviceCaps(pDIS->hDC, LOGPIXELSY), 72), 0, 0, 0, nBold, nItalic, nUnderline, nStrikeOut, DEFAULT_CHARSET, OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, FontName);

    hBrushOld = SelectObject(pDIS->hDC, hBrush);
    hPenOld   = SelectObject(pDIS->hDC, hPen);
    hFontOld  = SelectObject(pDIS->hDC, hFont);

    SetTextColor(pDIS->hDC, TextColor);
    SetBkColor(pDIS->hDC,   BackColor);
    SetBkMode( pDIS->hDC, TRANSPARENT);

    if (nShape >= 0)
    {
      if (FrameColor2 <= 0xFFFFFF)
      {
        hBrush2 = CreateSolidBrush(FrameColor2);
        SelectObject(pDIS->hDC, hBrush2);

        RoundRect(pDIS->hDC, pDIS->rcItem.left, pDIS->rcItem.top, pDIS->rcItem.right, pDIS->rcItem.bottom, nShape, nShape);

        SelectObject(pDIS->hDC, hBrush);
        DeleteObject(hBrush2);

        RoundRect(pDIS->hDC, pDIS->rcItem.left + 2, pDIS->rcItem.top + 2, pDIS->rcItem.right - 2, pDIS->rcItem.bottom - 2, nShape, nShape);
      }
      else
        RoundRect(pDIS->hDC, pDIS->rcItem.left, pDIS->rcItem.top, pDIS->rcItem.right, pDIS->rcItem.bottom, nShape, nShape);
    }
    else
    {
      if (FrameColor2 <= 0xFFFFFF)
      {
        hBrush2 = CreateSolidBrush(FrameColor2);
        SelectObject(pDIS->hDC, hBrush2);

        Ellipse(pDIS->hDC, pDIS->rcItem.left, pDIS->rcItem.top, pDIS->rcItem.right, pDIS->rcItem.bottom);
        hRegn = CreateEllipticRgn(0, pDIS->rcItem.right-pDIS->rcItem.left, pDIS->rcItem.bottom-pDIS->rcItem.top,0);
        SetWindowRgn(MyControl,hRegn,TRUE);

        SelectObject(pDIS->hDC, hBrush);
        DeleteObject(hBrush2);

        Ellipse(pDIS->hDC, pDIS->rcItem.left + 2, pDIS->rcItem.top + 2, pDIS->rcItem.right - 2, pDIS->rcItem.bottom - 2);
        hRegn = CreateEllipticRgn(0, pDIS->rcItem.right-pDIS->rcItem.left, pDIS->rcItem.bottom-pDIS->rcItem.top,0);
        SetWindowRgn(MyControl,hRegn,TRUE);

      }
      else
        Ellipse(pDIS->hDC, pDIS->rcItem.left, pDIS->rcItem.top, pDIS->rcItem.right, pDIS->rcItem.bottom);
        hRegn = CreateEllipticRgn(0, pDIS->rcItem.right-pDIS->rcItem.left, pDIS->rcItem.bottom-pDIS->rcItem.top,0);
        SetWindowRgn(MyControl,hRegn,TRUE);
    }

    nTextH = DrawText(pDIS->hDC, Text, -1, &rcText, DT_CALCRECT | DT_NOCLIP);

    rcText.left  = pDIS->rcItem.left  + 3;
    rcText.right = pDIS->rcItem.right - 3;

    if (nTextH < (pDIS->rcItem.bottom - pDIS->rcItem.top - 2 * 3))
    {
      rcText.top    = (pDIS->rcItem.bottom - pDIS->rcItem.top - nTextH) / 2;
      rcText.bottom = rcText.top + nTextH;
    }
    else
    {
      rcText.top    = pDIS->rcItem.top    + 3;
      rcText.bottom = pDIS->rcItem.bottom - 3;
    }

    DrawText(pDIS->hDC, Text, -1, &rcText, DT_CENTER);

    SelectObject(pDIS->hDC, hBrushOld);
    SelectObject(pDIS->hDC, hPenOld);
    SelectObject(pDIS->hDC, hFontOld);

    DeleteObject(hBrush);
    DeleteObject(hPen);
    DeleteObject(hFont);
    hb_xfree(Text);
  }

LRESULT CALLBACK OwnButtonProc( HWND hButton, UINT Msg, WPARAM wParam, LPARAM lParam )

{
   static PHB_SYMB pSymbol = NULL;
   long int        r;
   TRACKMOUSEEVENT tme;

   switch( Msg )
   {
      case WM_LBUTTONDBLCLK:
         SendMessage( hButton, WM_LBUTTONDOWN, wParam, lParam );
         break;

      case WM_MOUSEMOVE:
         tme.cbSize      = sizeof( TRACKMOUSEEVENT );
         tme.dwFlags     = TME_LEAVE;
         tme.hwndTrack   = hButton;
         tme.dwHoverTime = 0;
         _TrackMouseEvent( &tme );

         if( ! pSymbol )
            pSymbol = hb_dynsymSymbol( hb_dynsymGet( "OBTNEVENTS" ) );

         if( pSymbol )
         {
            hb_vmPushSymbol( pSymbol );
            hb_vmPushNil();
            hb_vmPushNumInt( ( LONG_PTR ) hButton );
            hb_vmPushLong( Msg );
            hb_vmPushNumInt( wParam );
            hb_vmPushNumInt( lParam );
            hb_vmDo( 4 );
         }

         r = hb_parnl( -1 );

         return ( r != 0 ) ? r : DefWindowProc( hButton, Msg, wParam, lParam );

      case WM_MOUSELEAVE:
         if( ! pSymbol )
            pSymbol = hb_dynsymSymbol( hb_dynsymGet( "OBTNEVENTS" ) );

         if( pSymbol )
         {
            hb_vmPushSymbol( pSymbol );
            hb_vmPushNil();
            hb_vmPushNumInt( ( LONG_PTR ) hButton );
            hb_vmPushLong( Msg );
            hb_vmPushNumInt( wParam );
            hb_vmPushNumInt( lParam );
            hb_vmDo( 4 );
         }

         r = hb_parnl( -1 );

         return ( r != 0 ) ? r : DefWindowProc( hButton, Msg, wParam, lParam );
   }

   return CallWindowProc( ButtonOldWndProc, hButton, Msg, wParam, lParam );
}

#pragma ENDDUMP

