*+--------------------------------------------------------------------
*+
*+ Source Module => c:\hmg.3.4.4\0\MYBUTT2\\MYBUTTON.PRG
*+
*+    Copyright(C) 1983-2020 by Auge & Ohr
*+
*+    Functions: Init Procedure _InitMyButton()
*+               Procedure _DefineMyButton()
*+               Function MyButtonEventhandler()
*+               Procedure MyButtonSetFocus()
*+               Procedure MyButtonEnable()
*+               Procedure MyButtonDisable()
*+               Function SetMyButtonHandle()
*+               Function GetMyButtonHandle()
*+               Function SetMyButtonCaption()
*+               Function GetMyButtonCaption()
*+
*+    Reformatted by Click! 2.05.36 on Dec-18-2020 at  6:12 am
*+
*+--------------------------------------------------------------------

/*
   MyButton user functions
   Added Width and Height by Pablo César

   modify by Jimmy 2020/12
   Added CALLBACK

*/

#include "common.ch"
#include "MYBUTTON.CH"

#define WM_MOUSEMOVE          0x0200
#define WM_MOUSEHOVER         0x02A1
#define WM_MOUSELEAVE         0x02A3

#define WM_COMMAND            0x0111
#define BN_CLICKED            0

*+--------------------------------------------------------------------
*+
*+    Init Procedure _InitMyButton()
*+
*+--------------------------------------------------------------------
*+
INIT PROCEDURE _InitMyButton

   InstallEventHandler( 'MyButtonEventHandler' )
   InstallMethodHandler( 'SetFocus', 'MyButtonSetFocus' )
   InstallMethodHandler( 'Enable', 'MyButtonEnable' )
   InstallMethodHandler( 'Disable', 'MyButtonDisable' )
   InstallPropertyHandler( 'Handle', 'SetMyButtonHandle', 'GetMyButtonHandle' )
   InstallPropertyHandler( 'Caption', 'SetMyButtonCaption', 'GetMyButtonCaption' )

RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure _DefineMyButton()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE _DefineMyButton( ControlName, nRow, nCol, nWidth, nHeight, cCaption, bAction, cParent, lMultiline, gotfocus, lostfocus, nShape )

LOCAL nControlHandle, nId, nParentFormHandle, k, cMacroVar

   DEFAULT lostfocus TO ""
   DEFAULT gotfocus TO ""

   IF .NOT. _IsWindowDefined( cParent )
      MsgHMGError( "Window: " + cParent + " is not defined." )
   ENDIF

   IF _IsControlDefined( ControlName, cParent )
      MsgHMGError( "Control: " + ControlName + " Of " + cParent + " Already defined." )
   ENDIF

   cMacroVar := '_' + cParent + '_' + ControlName
   k := _GetControlFree()
   nId := _GetId()
   nParentFormHandle := GetFormHandle( cParent )
   nControlHandle := InitMyButton( nParentFormHandle, ;
                                   nRow, ;
                                   nCol, ;
                                   cCaption, ;
                                   nId, ;
                                   nWidth, ;
                                   nHeight, ;
                                   lMultiline )

PUBLIC &cMacroVar. := k

   _HMG_SYSDATA[ CTRL_TYPE ]           [ k ] := 'MYBUTTON'
   _HMG_SYSDATA[ CTRL_NAME ]           [ k ] := ControlName
   _HMG_SYSDATA[ CTRL_HANDLE ]         [ k ] := nControlHandle
   _HMG_SYSDATA[ CTRL_PARENT_HANDLE ]  [ k ] := nParentFormHandle
   _HMG_SYSDATA[ CTRL_ID ]             [ k ] := nId
   _HMG_SYSDATA[ CTRL_PROCEDURE ]      [ k ] := bAction
   _HMG_SYSDATA[ CTRL_PAGEMAP ]        [ k ] := {}
   _HMG_SYSDATA[ CTRL_VALUE ]          [ k ] := NIL
   _HMG_SYSDATA[ CTRL_INPUTMASK ]      [ k ] := .T.
   _HMG_SYSDATA[ CTRL_LOSTFOCUS ]      [ k ] := lostfocus
   _HMG_SYSDATA[ CTRL_GOTFOCUS ]       [ k ] := gotfocus
   _HMG_SYSDATA[ CTRL_ONCHANGE ]       [ k ] := ""
   _HMG_SYSDATA[ CTRL_DELETE_STATUS ]  [ k ] := .F.
   _HMG_SYSDATA[ CTRL_BKCOLOR ]        [ k ] := NIL
   _HMG_SYSDATA[ CTRL_FONTCOLOR ]      [ k ] := NIL
   _HMG_SYSDATA[ CTRL_DBLCLICK ]       [ k ] := ""
   _HMG_SYSDATA[ CTRL_HEADCLICK ]      [ k ] := {}
   _HMG_SYSDATA[ CTRL_ROW ]            [ k ] := nRow
   _HMG_SYSDATA[ CTRL_COL ]            [ k ] := nCol
   _HMG_SYSDATA[ CTRL_WIDTH ]          [ k ] := nWidth
   _HMG_SYSDATA[ CTRL_HEIGHT ]         [ k ] := nHeight
   _HMG_SYSDATA[ CTRL_SPACING ]        [ k ] := "T"
   _HMG_SYSDATA[ CTRL_CONTAINERROW ]   [ k ] := IF( _HMG_SYSDATA[ 183 ] > 0, _HMG_SYSDATA[ 333 ] [ _HMG_SYSDATA[ 183 ] ], - 1 )
   _HMG_SYSDATA[ CTRL_CONTAINERCOL ]   [ k ] := IF( _HMG_SYSDATA[ 183 ] > 0, _HMG_SYSDATA[ 334 ] [ _HMG_SYSDATA[ 183 ] ], - 1 )
   _HMG_SYSDATA[ CTRL_PICTURE ]        [ k ] := ""
   _HMG_SYSDATA[ CTRL_CONTAINERHANDLE ] [ k ] := 0
   _HMG_SYSDATA[ CTRL_FONTNAME ]       [ k ] := NIL
   _HMG_SYSDATA[ CTRL_FONTSIZE ]       [ k ] := NIL
   _HMG_SYSDATA[ CTRL_FONTATTRIBUTES ] [ k ] := NIL
   _HMG_SYSDATA[ CTRL_TOOLTIP ]        [ k ] := NIL
   _HMG_SYSDATA[ CTRL_RANGEMIN ]       [ k ] := 0
   _HMG_SYSDATA[ CTRL_RANGEMAX ]       [ k ] := 0
   _HMG_SYSDATA[ CTRL_CAPTION ]        [ k ] := cCaption
   _HMG_SYSDATA[ CTRL_VISIBLE ]        [ k ] := NIL
   _HMG_SYSDATA[ CTRL_HELPID ]         [ k ] := NIL
   _HMG_SYSDATA[ CTRL_FONTHANDLE ]     [ k ] := NIL
   _HMG_SYSDATA[ CTRL_BRUSHHANDLE ]    [ k ] := 0
   _HMG_SYSDATA[ CTRL_ENABLED ]        [ k ] := .T.
   _HMG_SYSDATA[ CTRL_MISCDATA1 ]      [ k ] := 0
   _HMG_SYSDATA[ CTRL_MISCDATA2 ]      [ k ] := { NIL, NIL, NIL, NIL, NIL, NIL, NIL, NIL }

RETURN

*+--------------------------------------------------------------------
*+
*+    Function MyButtonEventhandler()
*+
*+--------------------------------------------------------------------
*+
FUNCTION MyButtonEventhandler( hWnd, nMsg, wParam, lParam )

LOCAL i
LOCAL RetVal := Nil

   IF nMsg == WM_COMMAND
      i := ASCAN( _HMG_SYSDATA[ CTRL_HANDLE ], lParam )
      IF i > 0
         IF HiWord( wParam ) == BN_CLICKED
            RetVal := 0
            _DoControlEventProcedure( _HMG_SYSDATA[ CTRL_PROCEDURE ] [ i ], i )
         ENDIF
      ENDIF
   ENDIF
RETURN RetVal

*+--------------------------------------------------------------------
*+
*+    Procedure MyButtonSetFocus()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE MyButtonSetFocus( cWindow, cControl )

LOCAL i

   IF GetControlType( cControl, cWindow ) == 'MYBUTTON'
      SetFocus( GetControlHandle( cControl, cWindow ) )
      _HMG_SYSDATA[ USR_COMP_PROC_FLAG ] := .T.
   ELSE
      _HMG_SYSDATA[ USR_COMP_PROC_FLAG ] := .F.
   ENDIF
RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure MyButtonEnable()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE MyButtonEnable( cWindow, cControl )

LOCAL i

   IF GetControlType( cControl, cWindow ) == 'MYBUTTON'
      EnableWindow( GetControlHandle( cControl, cWindow ) )
      _HMG_SYSDATA[ USR_COMP_PROC_FLAG ] := .T.
   ELSE
      _HMG_SYSDATA[ USR_COMP_PROC_FLAG ] := .F.
   ENDIF
RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure MyButtonDisable()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE MyButtonDisable( cWindow, cControl )

LOCAL i

   IF GetControlType( cControl, cWindow ) == 'MYBUTTON'
      DisableWindow( GetControlHandle( cControl, cWindow ) )
      _HMG_SYSDATA[ USR_COMP_PROC_FLAG ] := .T.
   ELSE
      _HMG_SYSDATA[ USR_COMP_PROC_FLAG ] := .F.
   ENDIF
RETURN

*+--------------------------------------------------------------------
*+
*+    Function SetMyButtonHandle()
*+
*+--------------------------------------------------------------------
*+
FUNCTION SetMyButtonHandle( cWindow, cControl )

   IF GetControlType( cControl, cWindow ) == 'MYBUTTON'
      MsgExclamation( 'MyButton can not change its handle !', 'This Property is Read Only' )
   ENDIF
   _HMG_SYSDATA[ USR_COMP_PROC_FLAG ] := .F.
RETURN Nil

*+--------------------------------------------------------------------
*+
*+    Function GetMyButtonHandle()
*+
*+    Called from ( demo1.prg )   1 - function obtn_draw()
*+
*+--------------------------------------------------------------------
*+
FUNCTION GetMyButtonHandle( cWindow, cControl )

LOCAL RetVal := Nil

   IF GetControlType( cControl, cWindow ) == 'MYBUTTON'
      _HMG_SYSDATA[ USR_COMP_PROC_FLAG ] := .T.
      RetVal := GetControlHandle( cControl, cWindow )
   ELSE
      _HMG_SYSDATA[ USR_COMP_PROC_FLAG ] := .F.
   ENDIF
RETURN RetVal

*+--------------------------------------------------------------------
*+
*+    Function SetMyButtonCaption()
*+
*+--------------------------------------------------------------------
*+
FUNCTION SetMyButtonCaption( cWindow, cControl, cProperty, cValue )

   IF GetControlType( cControl, cWindow ) == 'MYBUTTON'
      _HMG_SYSDATA[ USR_COMP_PROC_FLAG ] := .T.
      SetWindowText( GetControlHandle( cControl, cWindow ), cValue )
   ELSE
      _HMG_SYSDATA[ USR_COMP_PROC_FLAG ] := .F.
   ENDIF
RETURN Nil

*+--------------------------------------------------------------------
*+
*+    Function GetMyButtonCaption()
*+
*+--------------------------------------------------------------------
*+
FUNCTION GetMyButtonCaption( cWindow, cControl )

LOCAL RetVal := Nil

   IF GetControlType( cControl, cWindow ) == 'MYBUTTON'
      _HMG_SYSDATA[ USR_COMP_PROC_FLAG ] := .T.
      RetVal := GetWindowText( GetControlHandle( cControl, cWindow ) )
   ELSE
      _HMG_SYSDATA[ USR_COMP_PROC_FLAG ] := .F.
   ENDIF

RETURN RetVal

*+ EOF: MYBUTTON.PRG

